searchData={"content_type":"text/markdown","items":[{"doc":"`ZenoIndexingEx`'s provides the `generate_key/2` function to help you\ngenerate a fractional index (a string-based key), that sorts \nlexicographically in between two existing keys `a` and `b`.\n\n# Fractional indexes with logarithmic key growth\n\nWhile there are a number of ways to generate an order key `c` that sorts in \nin between keys `a` and `b`, this particular module is an \nimplementation of Greenspan's _fractional indexing algorithm with logarithmic key growth_, \nwhich itself an improvement on \nEvan Wallace's _fractional indexing_ approach.","ref":"ZenoIndexingEx.html","title":"ZenoIndexingEx","type":"module"},{"doc":"# iex> ZenoIndexingEx.generate_key(nil, nil)\n    # {:ok, \"a0\"}\n    #\n    #\n    # iex> ZenoIndexingEx.generate_key(\"a0\", nil)\n    # {:ok, \"a1\"}","ref":"ZenoIndexingEx.html#module-examples","title":"Examples - ZenoIndexingEx","type":"module"},{"doc":"As described earlier, `generate_key/2` accepts keys `a`, `b`, and generates key `c`;\nin other words, all keys accepted and generated by `generate_key/2` must \nnot only conform to `order_key/0`, but also, when set to a string, \nmust be composed as follows:\n\n\"[_integer_component_][_fractional_component_]\"","ref":"ZenoIndexingEx.html#module-key-format","title":"Key format - ZenoIndexingEx","type":"module"},{"doc":"Generates an order key (i.e. a key that sorts lexicographically) in \nbetween the keys `a` and `b`.","ref":"ZenoIndexingEx.html#generate_key/2","title":"ZenoIndexingEx.generate_key/2","type":"function"},{"doc":"","ref":"ZenoIndexingEx.html#has_trailing_zeroes?/1","title":"ZenoIndexingEx.has_trailing_zeroes?/1","type":"function"},{"doc":"","ref":"ZenoIndexingEx.html#t:order_key/0","title":"ZenoIndexingEx.order_key/0","type":"type"}],"producer":{"name":"ex_doc","version":"0.37.1"},"proglang":"elixir"}